/*---------------------------------------------------------------------------
           MQO`3DfǂݍOpenGLŕ\Tv
---------------------------------------------------------------------------*/

#ifdef _WIN32
#include <windows.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#ifndef __APPLE__
#include <GL/gl.h>
#include <GL/glut.h>
#else
#include <OpenGL/gl.h>
#include <GLUT/glut.h>
#endif

#include "GLMetaseq.h"	// f[_


// O[oϐ
int g_mouseX = 0;	// }EXXW
int g_mouseY = 0;	// }EXYW
int g_rotX = 0;		// X̉]
int	g_rotY = 0;		// Ỷ]

MQO_MODEL g_mqoModel;	// MQOf


// vg^Cv錾
void mySetLight(void);
void Draw(void);
void Reshape (int w, int h);
void Keyboard(unsigned char key, int x, int y);
void Mouse(int button, int state, int x, int y);
void Motion(int x, int y);


// ̐ݒs֐
void mySetLight(void)
{
	GLfloat light_diffuse[]  = { 0.9, 0.9, 0.9, 1.0 };	// gUˌ
	GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };	// ʔˌ
	GLfloat light_ambient[]  = { 0.3, 0.3, 0.3, 0.1 };	// 
	GLfloat light_position[] = { 0.0, 0.0, 0.0, 1.0 };	// ʒuƎ

	// ̐ݒ
	glLightfv( GL_LIGHT0, GL_DIFFUSE,  light_diffuse );	 // gUˌ̐ݒ
	glLightfv( GL_LIGHT0, GL_SPECULAR, light_specular ); // ʔˌ̐ݒ
	glLightfv( GL_LIGHT0, GL_AMBIENT,  light_ambient );	 // ̐ݒ
	glLightfv( GL_LIGHT0, GL_POSITION, light_position ); // ʒuƎނ̐ݒ

	glShadeModel( GL_SMOOTH );	// VF[fBO̎ނ̐ݒ
	glEnable( GL_LIGHT0 );		// ̗L
}


// `֐
void Draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// 
	glClearColor(0.f, 0.f, 0.2f, 1.0);					// wiF
	glMatrixMode(GL_MODELVIEW);

	glEnable( GL_DEPTH_TEST );		// Bʏ̓Kp
	mySetLight();					// ̐ݒ
	glEnable( GL_LIGHTING );		// ON

	glPushMatrix();
		glTranslatef(0.0, -100.0, -400.0);	// sړ
		glRotatef( g_rotX, 1, 0, 0 );		// X]
		glRotatef( g_rotY, 0, 1, 0 );		// Y]
		mqoCallModel(g_mqoModel);			// MQOf̃R[
	glPopMatrix();

	glDisable( GL_LIGHTING );
	glDisable( GL_DEPTH_TEST );

	glutSwapBuffers();
}


// EBhEό`ɌĂ΂֐
void Reshape (int w, int h)
{
	double	znear = 10;
	double	fovy = 50;
	double	zfar = 10000;

	// r[|[gݒ
	glViewport(0, 0, w, h);

	// ˉeݒ
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(fovy, (double)w/h, znear, zfar);
}


// L[Cxg֐
void Keyboard(unsigned char key, int x, int y)
{
	switch (key) {
		case 'q':
		case 'Q':
		case 0x1b:
			exit(0);	// îƏI֐Ă΂j
		default:
			break;
	}
}


// }EXCxg֐
void Mouse(int button, int state, int x, int y)
{
	if ( state == GLUT_DOWN ) {
		g_mouseX = x;
		g_mouseY = y;				
	}
}


// }EXhbȌ֐
void Motion(int x, int y)
{
	int xd, yd;

	// }EXړʂ̎Zo
	xd = x - g_mouseX;
	yd = y - g_mouseY;

	// ]ʂ̐ݒ
	g_rotX += yd;
	g_rotY += xd;

	// }EXW̍XV
	g_mouseX = x;
	g_mouseY = y;
}


// I֐
void Quit(void)
{
	mqoDeleteModel( g_mqoModel );	// f̍폜
	mqoCleanup();					// GLMetaseq̏I
}


// main֐
int main(int argc, char *argv[])
{
	// 
	glutInit(&argc,argv);										// OpenGL
	glutInitWindowPosition(100, 50);							// EBhE̕\ʒu
	glutInitWindowSize(640, 480);								// EBhẼTCY
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);	// fBXvCݒ
	glutCreateWindow("MQO Loader for OpenGL");					// EBhE̐

	// f\鏀
	mqoInit();											// GLMetaseq̏
	g_mqoModel = mqoCreateModel("ninja.mqo",1.0);		// f̃[h

	// I֐̐ݒ
	atexit(Quit);

	// R[obN֐̐ݒ
	glutDisplayFunc(Draw);			// `揈֐̐ݒ
	glutIdleFunc(Draw);				// ACh̏֐̐ݒ
	glutReshapeFunc(Reshape);		// EBhEό`̏s֐̐ݒ
	glutKeyboardFunc(Keyboard);		// L[͎̏֐̐ݒ
	glutMouseFunc(Mouse);			// }EX͎̏֐̐ݒ
	glutMotionFunc(Motion);			// }EXhbȌ֐̐ݒ

	// Cxg҂̖[vɓ
	glutMainLoop();

	return 0;
}
